# -*- coding: utf-8 -*-
"""
Created on Wed Dec 21 14:18:29 2016

@author: akidribm
"""
from sortal import (transformSet, similarityMap, rule, primitiveSort, point2D, coordinate, lineSegment2D, line2D, label, weight, disjunctiveSort, attributeSort, affineTransform,  vector2D)
from copy import deepcopy

"""
============
FORM ALGEBRA
============
'Form Algebra' methods do not change the form that serves as the calling function, but return a new instance

METHODS:
  
SUM where new_form_1 is the union of formL1 and formL3
    new_form_1 = algebra.sum(formL1, formL3)

DIFFERENCE where new_form_2 is the form containing the set of elements left 
           after those in common between formL1 and formL3 are removed
           new_form_2 = algebra.difference(formL1, formL3)

PRODUCT where new_form_3 is the intersection of formL1 and formL3
        new_form_3 = algebra.product(formL1, formL3)
        
ALTERNATIVELY, sum, difference, and product are also part of the library. They can 
               be used  to directly change the receiving form, as show below.
               
               formL1.sum(formL3) -> stores sum of two forms in formL1
               formL1.difference(formL3) -> stores difference of two forms in formL1
               formL1.product(formL3) -> stores product of two forms in formL1
"""

class form_algebra: 
     
    def sum(self, A, B): 
        formC = deepcopy(A)
        formC.sum(B)
        return formC
        
    def difference(self, A, B): 
        formC = deepcopy(A)
        formC.difference(B)
        return formC
        
    def product(self, A, B): 
        formC = deepcopy(A)
        formC.product(B)
        return formC