# -*- coding: utf-8 -*-
"""
Created on Fri Jan  6 14:53:36 2017

@author: akidribm
"""
from sortal import (primitiveSort, point2D, lineSegment2D, line2D, point3D, lineSegment3D, line3D, label, weight, rWeight, disjunctiveSort, attributeSort, planeSegment2D)

# The sorts in this file can be edited by the user to suit what sort types are needed

####################
#   2D SORT TYPES  #
####################
lineSegSort2D = primitiveSort ('lineSeg2D', lineSegment2D)

# planeSort: attribute sort of plane(ps: primitive plane sort) with weight(weightSort: primitive weight sort)
# In this case, planeSort is composed of weightSort and ps (which is a primitive, planeSegment2D sort)
# weightSort is also classed as primitive first
# To create a plane with a weight attribute, the primitive plane sort (ps) and the primitive weight sort (weightSort)
# are combined together as an attribute sort with plane sort as the base sort and weightSort as the attribute
planeS2D = primitiveSort('plane2D', planeSegment2D)
weightSort = primitiveSort('weight', weight, '255')
labelSort = primitiveSort('label', label)
planeSort2D = attributeSort('planeAttrib2D', planeS2D, labelSort)

# pointSort: attribute sort of point(pointS: primitive point sort) with label(labelSort: primitive label sort)
# To create a point with a label attribute, the primitive point sort (pointS) and the primitive label sort(labelSort)
# are combined into an attribute sort with pointS as the base sort and labelSort as the attribute
pointS2D = primitiveSort('point', point2D)
pointSort2D = attributeSort('pointAttrib2D', pointS2D,labelSort)

# To combine two sort types such as a plane and a point in one form, these must be combined in a disjunctive sort
comp2D = [planeSort2D, pointSort2D]
disjunctive2D = disjunctiveSort('disjunctive2D', comp2D)

####################
#   3D SORT TYPES  #
####################
pointSort3D = primitiveSort('point3D', point3D)
lineSegSort3D = primitiveSort('lineSeg3D', lineSegment3D)
    
comp3D = [lineSegSort3D, pointSort3D]
disjunctive3D = disjunctiveSort('disjunctive3D', comp3D)

####################

sort_types = {'lineSeg2D': lineSegSort2D, 'planeS2D': planeS2D, 'weight': weightSort, 'planeSort2D': planeSort2D, 'pointS2D': pointS2D, 'label': labelSort, 'pointSort2D': pointSort2D, 'comp2D': comp2D, 'disjunctive2D': disjunctive2D, 'pointSort3D': pointSort3D, 'lineSeg3D': lineSegSort3D, 'disjunctive3D': disjunctive3D}
