# -*- coding: utf-8 -*-
"""
Created on Fri Nov  4 11:01:10 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
from builtins import range
from builtins import super
from builtins import str
"""
from future import standard_library
standard_library.install_aliases()
"""
from .special import special

class enumerative(special):
    type = 'ind-enumerative'
    def __init__(self, sort, value = -1, *args, **kwargs):
        super(enumerative, self).__init__(sort)
        if isinstance(value, int):
            self.value = value
            return
        enums = self.sort.baseSort().arguments
        for i in range(len(enums.values)):
            if enums.values[i] == value:
                self.value = i
                return 
        raise ValueError('Argument is not a valid enumerative value')
    
        
    def strValue(self):
        return self.sort.baseSort().arguments.values[self.value]
        
    def ranking(self, other):
        return self.sort.baseSort().arguments.rankings[self.value][other.value]
    
    def printVal(self):
        return str(self.strValue())
        
    def getValue(self):
        return self.strValue()
        
    def isNil(self):
        if self.value == -1:
            return True
        return False
        
    def equals(self, other):
        return self.value == other.value
        
    def compareValue(self, other):
        d = self.value - other.value
        if d < 0:
            return -1
        elif d > 0:
            return 1
        return 0
    
    def contains(self, other):
        if self.sort != other.sort:
            raise ValueError('enumeratives must be of the same sort')
        return (not self.isNil()) and (not other.isNil()) and self.compareValue(other) == 0
        
    def combine(self, other):
        if other is None or other.isNil():
            return not self.isNil()
        if self.isNil():
            self.value = other.value
        else:
            self.value = self.ranking(other)
        return True
        
    def common(self, other):
        if self.isNil() or other == None or other.isNil():
            return False
        return self.compareValue(other) == 0
        
    def complement(self, other):
        if self.isNil():
            return False
        if other is None or other.isNil():
            return True
        return self.compareValue(other) != 0
        
    def getMinInd(self):
        return enumerative(self.sort)
        
    def symcomplement(self, other):
        if self.isNil():
            return False
        if other is None or other.isNil():
            return True
        return self.compareValue(other) != 0
        
    def replicateInd(self):
        return enumerative(self.sort, self.value)

    @staticmethod
    def parse(reader, sort):
        ind = enumerative(sort, int(reader.value()))
        reader.newToken()
        return ind