# -*- coding: utf-8 -*-
"""
Created on Wed Sep  7 11:27:45 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

version = '__ver_14/11/2018__'

from .struct.coordinate import coordinate
from .struct.vector import vector2D ,vector3D
from .struct.key import key

#import all in/out reader/writer
from .io.parseReader import parseReader
from .io.sdlParser import sdlParser

#import all sorts
from .sort.sort import sort
from .sort.sorts import sorts
from .sort.primitiveSort import primitiveSort
from .sort.attributeSort import attributeSort
from .sort.disjunctiveSort import disjunctiveSort
from .sort.compoundSort import compoundSort
from .sort.parameter.argument import argument

#import all maps >>>>>>>>>.
from .map.distinguishable import distinguishable
from .map.mapping import mapping
from .map.exactMap import exactMap
from .map.similarityMap import similarityMap2D
from .map.similarityMap3D import similarityMap3D
from .map.graphMap import graphMap
from .map.graphMap3D import graphMap3D
from .map.parametricMap import parametricMap

#import all transforms >>>>>>>>>>>
from .transform.transform import transform
from .transform.transformSet import transformSet
from .transform.affineTransform import affineTransform2D, affineTransform3D
from .transform.graphTransform import graphTransform, graphTransform3D
from .transform.paramSet import paramSet

#import all forms
from .form.form import form
from .form.multiplyForm import multiplyForm
from .form.singlyForm import singlyForm
from .form.areal import areal
from .form.discrete import discrete
from .form.curve import curve
from .form.ordinal import ordinal
from .form.interval import interval
from .form.cyclical import cyclical
from .form.coForm import coForm
from .form.metaForm import metaForm
from .form.specialForm import specialForm

#import all individuals
from .ind.individual import individual

from .ind.color import color
from .ind.date import date
from .ind.enumerative import enumerative
from .ind.imageUrl import imageUrl
from .ind.label import label
from .ind.numeric import numeric
from .ind.url import url
from .ind.point import point2D, point3D
from .ind.pointP import pointP2D, pointP3D


from .ind.weight import weight
from .ind.rWeight import rWeight

from .ind.line import line2D, line3D
from .ind.lineSegment import lineSegment2D, lineSegment3D
from .ind.lineSegmentP import lineSegmentP2D, lineSegmentP3D

from .ind.plane import plane2D, plane3D
from .ind.planeSegment import planeSegment2D
from .ind.planeSegment3D import planeSegment3D
from .ind.planeSegmentP import planeSegmentP2D, planeSegmentP3D

from .ind.bezierCurve import bezierCurve2D, bezierCurve3D
from .ind.bezierCurveP import bezierCurveP2D, bezierCurveP3D

from .ind.circle import circle2D, circle3D
from .ind.circleP import circleP2D, circleP3D
from .ind.circularArc import circularArc2D, circularArc3D
from .ind.ellipse import ellipse2D, ellipse3D
from .ind.ellipseP import ellipseP2D, ellipseP3D
from .ind.ellipticalArc import ellipticalArc2D, ellipticalArc3D

#import descriptions
from .ind.description import description 
from .ind.descriptions.literal import literal 
from .ind.descriptions.symbols import symbols 

"""
from .ind.descriptions.condition import condition 
from .ind.descriptions.numberLiteral import numberLiteral 
from .ind.descriptions.numericExpression import numericExpression 
from .ind.descriptions.parameter import parameter 
from .ind.descriptions.reference import reference 
from .ind.descriptions.stringExpression import stringExpression 
from .ind.descriptions.stringLiteral import stringLiteral 
from .ind.descriptions.tuple import tupleDesc
from .ind.descriptions.tupleExpression import tupleExpression 
"""

#import all crossAlgebra
from .ind.crossAlgebra.crossAlgebraPlane import crossAlgebraPlane2D

#import all grammar
from .grammar.fragment import fragment
from .grammar.derivation import derivation
from .grammar.ruleAnalysis import ruleAnalysis
from .grammar.ruleApplication import ruleApplication
from .grammar.detection import detection
from .grammar.rules.rule import rule
from .grammar.rules.flow import flow



similarityMap = similarityMap2D
affineTransform = affineTransform2D

sortNames = sort.register

individualList = [vector2D, vector3D,
                  date, imageUrl, label, url, weight, numeric,
                  point2D, point3D, 
                  line2D, line3D, lineSegment2D, lineSegment3D,
                  plane2D, planeSegment2D,
                  enumerative]

#define all modules
__all__  = [#struct
            "coordinate", "vector2D", "vector3D", "key",
        
            #io
            "sdlParser", "parseReader",
            
            #sorts
            "sort", "sorts", "primitiveSort", "attributeSort", 
            "disjunctiveSort", "compoundSort", 
            "sortNames",
            
            #map
            "distinguishable", 
            "exactMap",
            "similarityMap2D", 'similarityMap3D', 'similarityMap',
            "parametricMap", "paramSet",
            "graphMap", "graphMap3D",
            
            #transform
            "transform", "transformSet", 
            "affineTransform", "affineTransform2D", "affineTransform3D",
            "graphTransform", "graphTransform3D",
            
            #forms
            "form", "multiplyForm", "singlyForm", "discrete", "ordinal", 
            "interval", "coForm", "metaForm", 
            
            #individuals
            "individual", 
            "date", "imageUrl", "label", "url",
            "weight", "rWeight", 
            "numeric",
            "point2D", "point3D", "pointP2D", "pointP3D",
            "line2D", "line3D", "lineSegment2D", "lineSegment3D", "lineSegmentP2D", "lineSegmentP3D",
            "plane2D", "plane3D", "planeSegment2D", "planeSegment3D", "planeSegmentP2D", "planeSegmentP3D",
            "bezierCurve2D", "bezierCurveP2D",            
            "bezierCurve3D", "bezierCurveP3D",            
            "circle2D", "circleP2D", "circle3D", "circleP3D", "circularArc2D", "circularArc3D",
            "ellipse2D", "ellipseP2D", "ellipse3D", "ellipseP3D", "ellipticalArc2D", "ellipticalArc3D",
            
            "enumerative", "color",
            
            "crossAlgebraPlane2D",
            
            #description
            "description", 
                #"condition", "function", "literal", "numberLiteral",
                #"numericExpression", "parameter", "reference", "stringExpression", 
                #"stringLiteral", "tupleDesc", "tupleExpression",
            
            #grammar
            "fragment", "derivation", "ruleAnalysis", "ruleApplication", "detection", "rule", "flow"]



reg = [[date, discrete , argument.argumentType.LOCALE, exactMap, mapping.DISCRETE],
       [imageUrl, discrete , argument.argumentType.NONE, exactMap, mapping.DISCRETE],
       #[key, discrete , 'IDENTIFIER', exactMap, mapping.DISCRETE],
       [label, discrete , argument.argumentType.NONE, exactMap, mapping.DISCRETE],
       [numeric, discrete , argument.argumentType.NONE, exactMap, mapping.DISCRETE],
       [url, discrete , argument.argumentType.NONE, exactMap, mapping.DISCRETE],

       [weight, ordinal , argument.argumentType.UPPERBOUND, exactMap, mapping.LINEAR],
       [rWeight, ordinal , argument.argumentType.UPPERBOUND, exactMap, mapping.LINEAR],

       [point2D, discrete , argument.argumentType.NONE, similarityMap2D, mapping.DISCRETE],
       [point3D, discrete , argument.argumentType.NONE, similarityMap3D, mapping.DISCRETE],
       [pointP2D, discrete , argument.argumentType.NONE, graphMap, mapping.DISCRETE],
       [pointP3D, discrete , argument.argumentType.NONE, graphMap3D, mapping.DISCRETE],

       [line2D, discrete , argument.argumentType.NONE, similarityMap2D, mapping.DISCRETE],
       [line3D, discrete , argument.argumentType.NONE, similarityMap3D, mapping.DISCRETE],
       [lineSegment2D, interval , argument.argumentType.NONE, similarityMap2D, mapping.LINEAR],
       [lineSegment3D, interval , argument.argumentType.NONE, similarityMap3D, mapping.LINEAR],
       [lineSegmentP2D, interval , argument.argumentType.NONE, graphMap, mapping.PARAMETRIC_LINEAR],
       [lineSegmentP3D, interval , argument.argumentType.NONE, graphMap3D, mapping.PARAMETRIC_LINEAR],

       [plane2D, discrete, argument.argumentType.NONE, similarityMap2D, mapping.DISCRETE],
       [plane3D, discrete, argument.argumentType.NONE, similarityMap3D, mapping.DISCRETE],
       [planeSegment2D, coForm, argument.argumentType.NONE, similarityMap2D, mapping.PLANAR],
       [planeSegment3D, areal, argument.argumentType.NONE, similarityMap3D, mapping.PLANAR],
       [planeSegmentP2D, coForm, argument.argumentType.NONE, graphMap, mapping.PLANAR],
       [planeSegmentP3D, areal, argument.argumentType.NONE, graphMap3D, mapping.PLANAR],

       [bezierCurve2D, curve, argument.argumentType.NONE, similarityMap2D, mapping.LINEAR],
       [bezierCurveP2D, curve, argument.argumentType.NONE, graphMap, mapping.LINEAR],
       [bezierCurve3D, curve, argument.argumentType.NONE, similarityMap3D, mapping.LINEAR],
       [bezierCurveP3D, curve, argument.argumentType.NONE, graphMap3D, mapping.LINEAR],

       [circle2D, discrete, argument.argumentType.NONE, similarityMap2D, mapping.DISCRETE],
       [circleP2D, discrete, argument.argumentType.NONE, graphMap, mapping.DISCRETE],
       [circle3D, discrete, argument.argumentType.NONE, similarityMap3D, mapping.DISCRETE],
       [circleP3D, discrete, argument.argumentType.NONE, graphMap3D, mapping.DISCRETE],
       [circularArc2D, cyclical, argument.argumentType.NONE, similarityMap2D, mapping.CYCLIC],
       [circularArc3D, cyclical, argument.argumentType.NONE, similarityMap3D, mapping.CYCLIC],

       [ellipse2D, discrete, argument.argumentType.NONE, similarityMap2D, mapping.DISCRETE],
       [ellipseP2D, discrete, argument.argumentType.NONE, graphMap, mapping.DISCRETE],
       [ellipse3D, discrete, argument.argumentType.NONE, similarityMap3D, mapping.DISCRETE],
       [ellipseP3D, discrete, argument.argumentType.NONE, graphMap3D, mapping.DISCRETE],
       [ellipticalArc2D, cyclical, argument.argumentType.NONE, similarityMap2D, mapping.CYCLIC],
       [ellipticalArc3D, cyclical, argument.argumentType.NONE, similarityMap3D, mapping.CYCLIC],

       [enumerative, specialForm, argument.argumentType.ENUMERATION, exactMap, mapping.DISCRETE],
       [color, specialForm, argument.argumentType.COLORMODE, exactMap, mapping.DISCRETE],

       [description, discrete, argument.argumentType.NONE, parametricMap, mapping.DISCRETE],

       ]
       
for i in reg:
    primitiveSort.register(i[0],i[1],i[2],i[3],i[4])
    
primitiveSort('__dummyPlane3D__', plane3D, dummy = True)
primitiveSort('__dummyLine3D__', line3D, dummy = True)
primitiveSort('__dummyLine2D__', line3D, dummy = True)
primitiveSort('__dummyDesc__', description, dummy = True)

reg = [[exactMap, 0],
       [similarityMap2D, 7],
       [similarityMap3D, 7],
       [parametricMap, 1]]
for i in reg:
    mapping.register(i[0],i[1])
    

PI = literal.createLiteral('pi')
NIL = literal.createLiteral('nil')
E = literal.createLiteral('e')
TRUE = literal.createLiteral('true')
FALSE = literal.createLiteral('false')
PLUS_OP = literal.createLiteral(symbols.PLUS)
MINUS_OP = literal.createLiteral(parseReader.MINUS)
TIMES_OP = literal.createLiteral(symbols.TIMES)
DIVIDED_OP = literal.createLiteral(symbols.DIVIDED)
MODULO_OP = literal.createLiteral(symbols.MODULO)
POWER_OP = literal.createLiteral(symbols.POWER)


def cleanup():
    sort.cleanup()
    rule.cleanup()
    