# -*- coding: utf-8 -*-
"""
Created on Tue Sep  6 12:37:21 2016

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import

from builtins import str
"""
from future import standard_library
standard_library.install_aliases()
"""
from ..visit.elementVisitor import elementVisitor
from ..struct.fragmentTree import treeLink
from .fragment import fragment

class ruleAnalysis(elementVisitor):
    def __init__(self, lhs):
        self.fragments = []
        self.roots = []
        self.maps = {}
        self.current = None
        lhs.accept(self)
        self.setRefl(1)
        
    def setRefl(self, num):
        for i in self.maps.values():
            if i.__class__.type == 'map-distinguishable-similarityMap2D' or i.__class__.type == 'map-distinguishable-similarityMap3D':
                i.reflection = num
        return

    def getMap(self, sort, mappingSort):
        if 'sort' in sort.type:
            mapping = sort.baseSort().mapping()
        else:
            mapping = sort
            
        if mapping.type == 'map-parametric' or not isinstance(mappingSort, str):
            mapString = mapping.type
        else:
            mapString = mappingSort + '=|=' + mapping.type      
            if mapString not in self.maps:
                mapString = mapping.type
        return self.maps[mapString]
        """
        return self.maps[mapping]
        """
            
            
    def hasMap(self, map):
        for i in self.maps:
            if map.type in i:
                return True
        return False
        return map in self.maps
    
    def makeFragments(self, sort, parent, mappingSort):
        frag = treeLink(fragment(sort), parent)
        self.fragments.append(frag)
        if parent is None:
            self.roots.append(frag)
        else: parent.children.append(frag)
        mapping = sort.baseSort().mapping()
        
        if mapping.type == 'map-parametric' or not isinstance(mappingSort, str):
            mapString = mapping.type
        else:
            mapString = mappingSort + '=|=' + mapping.type      

        if mapString not in self.maps:
            newMapping = mapping.getInstance()
            newMapping.id = mapString
            self.maps[mapString] = newMapping
        """
        if mapping not in self.maps:
            self.maps[mapping] = mapping.getInstance()
        """
            
            
        return frag
        
    def visitEnter(self, visit, assignment):
        if 'ind' in visit.type:
            if len(self.fragments) == 0:
                self.current = self.makeFragments(visit.sort, None, assignment)
            self.current.content.addIndividual(self.getMap(visit.sort, assignment), visit) 

        elif 'form' in visit.type:
            if visit.sort.type == 'sort-disjunctive' or visit.sort.type == 'sort-compound':
                return True
            if visit.assoc is None or self.current is None:
                self.current = self.makeFragments(visit.sort, None, assignment)
            elif self.current.content.sort != visit.sort:
                found = False
                for i in self.current.children:
                    if i.content.sort == visit.sort:
                        self.current = i
                        found = True
                if found == False:
                    self.current = self.makeFragments(visit.sort, self.current, assignment)
        return True
        
    def visitLeave(self, visit):
        if 'ind' in visit.type:
            return
        elif 'form' in visit.type:
            if visit.sort.type == 'sort-disjunctive':
                return
            if self.current is not None and self.current.content.sort == visit.sort:
                self.current = self.current.parent
        return 
        
    def visitAssoc(self):
        return 
        
    def unsetVisitedAll(self):
        for i in self.fragments:
            i.content.visited = False
            
        