# -*- coding: utf-8 -*-
"""
Created on Mon Jan 29 09:24:17 2018

@author: akibdpt
"""
from __future__ import unicode_literals
from __future__ import print_function
from __future__ import division
from __future__ import absolute_import
from builtins import range
from builtins import super
from builtins import str

from .sort import sort
from ..form.metaForm import metaForm

class compoundSort(sort):
    separator = ' + '
    type = 'sort-compound'
    
    def __init__(self, name, component = [], *args, **kwargs):
        if self.checkSort(name) == True:
            raise ValueError('A sort with name '+name+' already exists')
        super(compoundSort, self).__init__(name)
        for i in component:
            if i.type != 'sort-disjunctive':
                raise ValueError('Compound sort '+name+' only take disjunctive sorts as components. A '+i.type[5:]+' sort named '+i.name+' is inputted')
        self.component = component
        self.description = self.description(self.component)
        return
        
    @classmethod
    def create(cls, name, component = []):
        if sort.checkSort(name) == True: 
            s = sort.getSort(name)
            if s.type != 'sort-compound' or component != s.component:
                for i in component:
                    print(i)
                print()
                for i in s.component:
                    print(i)
                raise ValueError('A sort with name '+name+' already exists')
            return s
        return compoundSort(name, component)
        
    def __eq__(self,other):
        if self.type != other.type:
            return False
        for i in self.component:
            check = False
            for j in other.component:
                if i == j:
                    check = True
            if check == False:
                return False
        return True
    
    """
    add a component sort to this sort
    """
    def addComponent(self, sort):
        for i in self.component:
            if sort.name == i.name:
                return
        self.component.append(sort)

    @staticmethod
    def sameComponent(component):
        uniqueComp = compoundSort.manageComp(component)
        for name in sort.register:
            s = sort.register[name]
            if s.type != 'sort-disjunctive':
                continue
            if uniqueComp == s.component:
                return s
        return False
    
    """
    creating the description for this sort
    """
    def description(self, component):
        if len(component) <= 1:
            desc = ''
            for i in component:
                desc += i.description
        else:
            desc = '('
            for i in component:
                if desc == '(':
                    desc += i.description
                else:
                    desc += compoundSort.separator + i.description
            desc += ')'
        return desc
        
    """
    checking if this sort contain other sort
    """
    def contains(self, other):
        if other.type == 'sort-compound':
            for i in other.component:
                Check = False
                for j in self.component:
                    if j.contains(i):
                        Check = True
                if Check == False:
                    return False
            return True
        else:
            for i in self.component:
                if i.contains(other):
                    return True
        return False
        
    """
    checking if this sort contain other sort
    """
    def complementSort(self, other):
        if not self.contains(other):
            raise ValueError("Compound sort "+self.name+" does not contain the sort named "+other.name)
        comp = []
        if other.type != 'sort-compound':
            for i in self.component:
                if i == other:
                    continue
                comp.append(i)
        else:
            for i in self.component:
                check = False
                for j in other.component:
                    if i == j:
                        check = True
                        break
                if check:
                    continue
                comp.append(i)
        nName = newName = self.name+'_'+other.name+'_complement'
        count = 0
        while self.checkSort(nName):
            nName = newName+str(count)
            count+=1
        return compoundSort(nName, comp)
        
    """
    dimension of this sort is 0
    """
    def dimension(self):
        return 0
        
    """
    creating a new metaform of this sort
    """    
    def newForm(self):
        try:
            form = metaForm(self)
            return form
        except:
            print('exception')
    
    